COMPANY_NAME = u"GridMarkets"
ROOT_ATTRIBUTE_ID = "GM_PROJECT_NAME"

ENUM_SUBTYPE_PRODUCT_VERSIONS = "PRODUCT_VERSIONS"
BLENDER_VERSIONS_ENUM_ID = "BLENDER_VERSION"

"""
BLENDER_2_80_MAIN_PROJECT_FILE = "BLENDER_2_80_MAIN_PROJECT_FILE"
BLENDER_2_80_RENDER_ENGINE = "BLENDER_2_80_RENDER_ENGINE"
BLENDER_2_79_MAIN_PROJECT_FILE = "BLENDER_2_79_MAIN_PROJECT_FILE"
BLENDER_2_79_RENDER_ENGINE = "BLENDER_2_79_RENDER_ENGINE"
"""


class PROJECT_ATTRIBUTE_IDS:
    PROJECT_NAME = ROOT_ATTRIBUTE_ID
    PRODUCT = "PRODUCT"
    PRODUCT_VERSION = "PRODUCT_VERSION"
    BLENDER_VERSION = "BLENDER_VERSION"
    VRAY_VERSION = "VRAY_VERSION"
    MAYA_VERSION = "MAYA_VERSION"
    NUKE_VERSION = "NUKE_VERSION"


class PROJECT_TYPE_IDS:
    MAYA_PROJECT = "MAYA_PROJECT"
    NUKE_PROJECT = "NUKE_PROJECT"


class JOB_DEFINITION_IDS:
    BLENDER_2_8X_CYCLES = 'BLENDER_2_8X_CYCLES'
    MAYA = 'MAYA'
    NUKE = 'NUKE'


class API_KEYS:
    PROJECT_NAME = "project_name"
    SUBMISSION_NAME = "submission_name"
    JOB_NAME = "name"
    APP = "app"
    APP_VERSION = "app_version"
    PATH = "path"
    FRAMES = "frames"
    OUTPUT_PREFIX = "output_prefix"
    OUTPUT_FORMAT = "output_format"
    REMOTE_OUTPUT_FOLDER_PATH = "remote_output_folder_path"
    LOCAL_DOWNLOAD_PATH = "local_download_path"
    WATCH_FILES = "watch_files"
    AUTO_DOWNLOAD = "auto_download"
    RENDER_ENGINE = "engine"
    RENDERER = "renderer"
    CAMERA = "camera"
    OUTPUT_WIDTH = "output_width"
    OUTPUT_HEIGHT = "output_height"
    SCENE_FILE_PATH_UNUSED = "scene_file_path_unused"
    GPU = "gpu"
    MACHINE_TYPE = "machine_type"
    INSTANCES = "instances"
    PROJECT_TYPE_ID = "project_type_id"
    REMAP = "remap"


class SUBTYPE_KEYS:
    class STRING:
        class PATH:
            FILE_MODE = "FILE_MODE"
            FILE_PATH = "FILE_PATH"
            DIR_PATH = "DIR_PATH"

    class ENUM:
        class PRODUCT_VERSIONS:
            PRODUCT = "PRODUCT"
            MATCH = "MATCH"

        class MACHINE_TYPE:
            PRODUCT = "PRODUCT"
            OPERATION = "OPERATION"
            USE_GPU_DEFAULT = "USE_GPU_DEFAULT"


class PRODUCTS:
    BLENDER = u"blender"
    VRAY = u"vray"
    MOE = u"moe"
    MAYA = u"maya"
    NUKE = u"nuke"


class OPERATION_TYPES:
    RENDER = u"render"


class BLENDER_VERSIONS:
    V_2_81A = "2.81a"
    V_2_80 = "2.80"
    V_2_79B = "2.79b"
    SERIES_2_8X = "^([2]\\.)([1-7]\\d)"
    SERIES_2_7X = "^([2]\\.)([8]\\d)"


class BLENDER_ENGINES:
    CYCLES = "CYCLES"
    EEVEE = "EEVEE"
    INTERNAL = "INTERNAL"


class VRAY_VERSIONS:
    V_3_60_03 = "3.60.03"
    V_3_60_04 = "3.60.04"
    V_3_60_05 = "3.60.05"
    V_4_02_05 = "4.02.05"
    V_4_10_01 = "4.10.01"
    V_4_10_02 = "4.10.02"


class ATTRIBUTE_NAMES:
    PRODUCT = "app"
