__all__ = 'ProjectDefinitionSchema'

from . import constants as api_constants
from gm_meta_plugin.project_definition_schema import ProjectDefinitionSchema as MetaProjectDefinitionSchema


class ProjectDefinitionSchema(MetaProjectDefinitionSchema):

    def __init__(self, plugin, project_attributes):

        # get the root project attribute from the project attribute list
        for project_attribute in project_attributes:
            if project_attribute.get_id() == api_constants.ROOT_ATTRIBUTE_ID:
                root_project_attribute = project_attribute
                break
        else:
            raise ValueError("Could not find root project attribute")

        MetaProjectDefinitionSchema.__init__(self, plugin, root_project_attribute, project_attributes)
