__all__ = 'ProjectInstanceBuilder'

from gm_meta_plugin.project_instance_builder import ProjectInstanceBuilder as MetaProjectInstanceBuilder
from gm_meta_plugin.attribute_types import AttributeType
from gm_meta_plugin.gridmarkets import constants as api_constants


class ProjectInstanceBuilder(MetaProjectInstanceBuilder):

    def get_project_attributes(self, attributes=None, force_transition=False, is_remote=False):
        root = self.get_root_project_attribute()
        attributes = attributes if attributes is not None else {}

        project_attribute_instance = root

        while True:
            attribute = project_attribute_instance.get_attribute()

            if attribute.get_type() == AttributeType.NULL:
                attributes[api_constants.API_KEYS.PROJECT_TYPE_ID] = project_attribute_instance.get_id()
                return attributes

            # add attribute value
            value = project_attribute_instance.get_value(is_remote=is_remote)
            attributes[attribute.get_key()] = value

            project_attribute_instance = project_attribute_instance.transition(value, force_transition)
