__all__ = 'LogItem'


class LogItem:
    """
    A class representing a single logged message plus all the relevant accompanying information
    """

    def __init__(self, logger_name, level, date_time, message):
        self._logger_name = logger_name
        self._level = level
        self._date_time = date_time
        self._message = message

    def get_logger_name(self):
        return self._logger_name

    def get_level(self):
        return self._level

    def get_date_time(self):
        return self._date_time

    def get_date(self):
        return self._date_time.strftime("%Y-%m-%d")

    def get_time(self):
        return self._date_time.strftime("%H:%M:%S")

    def get_message(self):
        return self._message

    def serialize(self):
        return self.get_date() + ' ' + \
               self.get_time() + ' ' + \
               self.get_logger_name() + ' ' + \
               self.get_level() + ' ' + \
               self.get_message()
