__all__ = 'Plugin'

from abc import abstractmethod


class Plugin(object):

    @abstractmethod
    def get_name(self):
        raise NotImplementedError

    @abstractmethod
    def get_version(self):
        raise NotImplementedError

    @abstractmethod
    def get_logging_coordinator(self):
        raise NotImplementedError

    @abstractmethod
    def get_preferences_container(self):
        raise NotImplementedError

    @abstractmethod
    def get_api_client(self):
        raise NotImplementedError

    @abstractmethod
    def get_user_interface(self):
        raise NotImplementedError

    @abstractmethod
    def get_remote_project_container(self):
        raise NotImplementedError

    @abstractmethod
    def get_application_attribute_source(self):
        raise NotImplementedError

    @abstractmethod
    def get_packed_scene_builder(self):
        raise NotImplementedError

    @abstractmethod
    def get_factory_collection(self):
        raise NotImplementedError

    def get_plugin_utils(self):
        raise NotImplementedError

    @abstractmethod
    def get_supported_applications(self):
        raise NotImplementedError
