__all__ = 'APIClient'

import gm_meta_plugin
import gridmarkets
from gm_meta_plugin.gridmarkets import GridMarketsAPIClient


class QtAPIClient(GridMarketsAPIClient):

    def sign_in_with_envoy(self):
        http_client = gridmarkets.http_client.HttpClient()

        method = "GET"
        url = gridmarkets.envoy_client.API_BASE + "/auth"

        try:
            resp = http_client.request(method, url)
        except gridmarkets.errors.APIError as e:
            e_msg = e.user_message

            # pretty error message for common errors
            if e_msg.startswith(u"Unexpected error communicating with Envoy.Please start Envoy"):
                e_msg = u"Unable to connect to Envoy."

            raise gm_meta_plugin.errors.APIClientError(message=e_msg)
        except Exception as e:
            raise gm_meta_plugin.errors.APIClientError(message=e.message)

        content = resp.json()

        user_name = content['Username']
        access_key = content['Key']

        if not (user_name and access_key):
            raise gm_meta_plugin.errors.InvalidUserError(u"Please sign-in to Envoy.")

        # create user
        user = gm_meta_plugin.User(content['Username'], content['Key'])

        api_client = self.get_plugin().get_api_client()
        api_client.sign_in(user, skip_validation=True)

    def sign_in(self, user, skip_validation = False):
        gm_meta_plugin.gridmarkets.GridMarketsAPIClient.sign_in(self, user, skip_validation=skip_validation)

        # attempt to get the cached api schema
        #api_schema = self.get_api_schema(ignore_cache=False)

        # create project attribute widgets so that all associated api calls the method uses gets cached
        #api_schema.create_project_attribute_widgets()
