__all__ = 'QtProjectInstanceBuilderFactory'

import gm_meta_plugin

from gm_qt_plugin.widgets.qt_project_instance_builder import QtProjectInstanceBuilder
from gm_qt_plugin.widgets.qt_project_attribute_instance import QtProjectAttributeInstance


class QtProjectInstanceBuilderFactory(gm_meta_plugin.ProjectInstanceBuilderFactory):

    def get_project_instance_builder(self, project_definition_schema):

        root_project_attribute = project_definition_schema.get_root_project_attribute()
        root_project_attribute_instance = QtProjectAttributeInstance(root_project_attribute)
        descendants = root_project_attribute_instance.get_descendants()
        project_attribute_instances = [root_project_attribute_instance] + descendants

        return QtProjectInstanceBuilder(self.get_plugin(),
                                        root_project_attribute_instance,
                                        project_attribute_instances)
