__all__ = 'ResizableStackedWidget'

from PySide2 import QtWidgets


class ResizableStackedWidget(QtWidgets.QStackedWidget):
    """
    A QStackedWidget which resizes to its current widget instead of taking the size of it's largest widget(s)
    """

    def sizeHint(self):
        return self.currentWidget().sizeHint()

    def minimumSizeHint(self):
        return self.currentWidget().minimumSizeHint()
